/*
aqtree3clickable.js

Converts an unordered list to an explorer-style tree, with clickable
icons

To make this work, simply add one line to your HTML:
<script type="text/javascript" src="aqtree3clickable.js"></script>

and then make the top UL of your nested unordered list of class
"aqtree3clickable".

That's it. No registration function, nothing.

http://www.kryogenix.org/code/browser/aqlists/

Stuart Langridge, November 2002
sil@kryogenix.org

Inspired by Aaron's labels.js (http://youngpup.net/demos/labels/) and Dave Lindquist's menuDropDown.js (http://www.gazingus.org/dhtml/?id=109)

*/

addEvent(window, "load", makeTreesC);
var teller
teller=0;

function makeTreesC() {
    // We don't actually need createElement, but we do
    // need good DOM support, so this is a good check.
    if (!document.createElement) return;
    
    uls = document.getElementsByTagName("ul");
    for (uli=0;uli<uls.length;uli++) {
        ul = uls[uli];
        if (ul.nodeName == "UL" && ul.className == "aqtree3clickable") {
            processULELC(ul);
        }
    }
}

function processULELC(ul) 
	{
		
    if (!ul.childNodes || ul.childNodes.length == 0) return;
    // Iterate LIs
    for (var itemi=0;itemi<ul.childNodes.length;itemi++) {
    	
    	teller++;
        var item = ul.childNodes[itemi];
        if (item.nodeName == "LI") {
            // Iterate things in this LI
            var div;
            var subul;
	    subul = "";
            for (var sitemi=0;sitemi<item.childNodes.length;sitemi++) {
                var sitem = item.childNodes[sitemi];
                

                
                switch (sitem.nodeName) {
                    case "DIV": 
                        div = sitem; 
                    break;
                    
                    case "UL": subul = sitem; 
                               processULELC(subul);
                               break;
                }
            }
            //if(divteller>1)
            //{
            if (subul) {
                associateELC(div,subul,teller);
            } else {
                div.parentNode.className = "aq3bullet";
            }
            //}
        }
    }
}

function associateELC(div,ul,itemi) {
    if (div.parentNode.className.indexOf('aq3open') == -1)
      div.parentNode.className = 'aq3closed';
    
      
      var openresults=get_cookie(window.location.pathname).split(" ")
  			
  			for (i=0 ; i < openresults.length ; i++)
  			{
  				if(openresults[i]=='a'+itemi)div.parentNode.className = 'aq3open';
  			}
 

       div.onclick = function () 
       {
        this.parentNode.className = (this.parentNode.className=='aq3open') ? "aq3closed" : "aq3open";
        //alert('change ' + document.getElementById("a95").className);
        if(this.parentNode.className=='aq3open')
        {
        	var openresults=get_cookie(window.location.pathname);
        	document.cookie=window.location.pathname+"="+openresults+ " " + 'a'+itemi;
        	alert(document.cookie);
        }	
        else
        {
        	//close
        	//if (get_cookie(window.location.pathname) != '')
        	//{
  			var openresults=get_cookie(window.location.pathname).split(" ")
  			var openones=""
  			for (i=0 ; i < openresults.length ; i++)
  			{
  				if(openresults[i]=='a'+itemi) openones=openones + " " + openresults[i]
  			}	
  			document.cookie=window.location.pathname+"="+openones;
  			alert(document.cookie);
        	//}
        }	
        return false;
    }
}

/*              Utility functions                    */

function addEvent(obj, evType, fn){
  /* adds an eventListener for browsers which support it
     Written by Scott Andrew: nice one, Scott */
  if (obj.addEventListener){
    obj.addEventListener(evType, fn, true);
    return true;
  } else if (obj.attachEvent){
	var r = obj.attachEvent("on"+evType, fn);
    return r;
  } else {
	return false;
  }
}

function get_cookie(Name) {
//Get cookie routine by Shelley Powers 
  var search = Name + "="
  var returnvalue = "";
  if (document.cookie.length > 0) {
    offset = document.cookie.indexOf(search)
    // if cookie exists
    if (offset != -1) { 
      offset += search.length
      // set index of beginning of value
      end = document.cookie.indexOf(";", offset);
      // set index of end of cookie value
      if (end == -1) end = document.cookie.length;
      returnvalue=unescape(document.cookie.substring(offset, end))
      }
   }
  return returnvalue;
}