/**
 * $Id: editor_plugin_src.js,v 1.1 2009/02/27 01:29:36 basjobsen5 Exp $
 *
 * @author Bas Jobsen
 * @copyright Copyright 2004-2007, W3masters, All rights reserved.
 */

/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('cyrillic_charmap');

var TinyMCE_cyrillic_charmapPlugin = {
	getInfo : function() {
		return {
			longname : 'Advanced HR',
			author : 'Moxiecode Systems AB',
			authorurl : 'http://tinymce.moxiecode.com',
			infourl : 'http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/cyrillic_charmap',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		}
	},

	getControlHTML : function(cn) {
		switch (cn) {
			case "cyrillic_charmap":
				return tinyMCE.getButtonHTML(cn, 'lang_insert_cyrillic_charmap_desc', '{$pluginurl}/images/cyrillic_charmap.gif', 'mceAdvancedHr');
		}

		return "";
	},

	/**
	 * Executes the mceAdvanceHr command.
	 */
	execCommand : function(editor_id, element, command, user_interface, value) 
	{
		// Handle commands
		switch (command) 
		{
			case "mceAdvancedHr":
				var template = new Array();

				template['file']   = '../../plugins/cyrillic_charmap/cyrillic_charmap.htm'; // Relative to theme
				template['width']  = 550;
				template['height'] = 300;

				template['width']  += tinyMCE.getLang('lang_cyrillic_charmap_delta_width', 0);
				template['height'] += tinyMCE.getLang('lang_cyrillic_charmap_delta_height', 0);

				
				tinyMCE.openWindow(template, {editor_id : editor_id, inline : "yes"});
					
				

				return true;
		}

		// Pass to next handler in chain
		return false;
	},

	handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		if (node == null)
			return;

		do {
			if (node.nodeName == "HR") {
				tinyMCE.switchClass(editor_id + '_cyrillic_charmap', 'mceButtonSelected');
				return true;
			}
		} while ((node = node.parentNode));

		tinyMCE.switchClass(editor_id + '_cyrillic_charmap', 'mceButtonNormal');

		return true;
	}
};

tinyMCE.addPlugin("cyrillic_charmap", TinyMCE_cyrillic_charmapPlugin);
