<?php
/*

EstrateCMS

EstrateCMS is a Content Management System for professional websites.

Copyright (C) 2004, 2005, Estrate, Rudolph Froger, The Netherlands
Website:        http://www.estrate.nl
Postal address: Estrate
                Oostsingel 57B
                2612HD Delft
                The Netherlands

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

A copy of the license should be in the file named LICENSE.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

define( 'MODULE_CMSARTICLES', TRUE );

class cmsarticles extends EstrateDB {
	var $id;
	var $title;
	var $content_a;		//intro or collumn 1 or unused
	var $content_b;		//bodytext or collumn 2 or default-text
	var $sid;
	var $pid;
	var $language;
	var $priority;
	var $status;
	var $startshow;
	var $stopshow;
	var $update_time;
	var $insert_time;
	var $content_type;
	var $showtitle;
	var $forumcatid;
	var $_acl;

	function cmsarticles( &$db) 
	{
		EstrateDB::EstrateDB( $db );
		
		require_once( CMS_CURRENT_LANGUAGE.'.php' );
        if( !defined( 'CMS_ARTICLES_CONTENT_TYPE' ) ) 
        {
           define( 'CMS_ARTICLES_CONTENT_TYPE', 'default' );
        }
	}

	function save() {
		if( EstrateDB::save() ) {
			/* priority niet aanpassen, moet via up/down */	
			
			$sync = array( 'sid', 'status', 'startshow', 'stopshow', 'update_time' );
			foreach( $sync as $value ) {
				$sql[]= "`".$value."`='".$this->$value."'";
			}
			$sql = implode( ", " , $sql );
			if( !$this->pid ) {
				return $this->_db->Execute( "UPDATE `".$this->_tablename."` SET ".$sql." WHERE `pid`='".$this->id."'" );
			} else {
				return $this->_db->Execute( "UPDATE `".$this->_tablename."` SET ".$sql." WHERE `pid`='".$this->pid."' OR `id`='".$this->pid."'" );
			}
		}
		return FALSE;
	}

	function show( $id ) 
	{
		$this->load( $id );
		$vars = array();
		$vars['id']=$id;
		$title_templ = cmstemplates::loadfile( 'article_title', $this->_tablename );
		
		if($this->showtitle=='on')$vars['title'] = cmstemplates::parse($title_templ,array('title'=>$this->title));
		
		$vars['content_a'] = str_replace('target="_blank"','rel="external"',$this->content_a);
		$vars['content_b'] = str_replace('target="_blank"','rel="external"',$this->content_b);
		
		if( $this->content_type == 'intro' ) {
			$template = 'cmsarticles_intro';
		} elseif( $this->content_type == 'columns' ) {
			$template = 'cmsarticles_columns';
		} else {
			$template = 'cmsarticles';
		}
		
		if($this->forumcatid>0)
		{
			
			$sql='SELECT `title` FROM `cmsbboardcategories` WHERE id = \''.$this->forumcatid.'\'';
			$rs = $this->_db->Execute($sql);
			$titel = niceurl($rs->fields('title')); //let op is titel is niet required?
			
			$sql='SELECT COUNT(*) as aantal FROM `cmsbboardmessages` WHERE `categoryid`  = \''.$this->forumcatid.'\'';
			$rs = $this->_db->Execute($sql);
			$aantal = $rs->fields('aantal');
			
			/* links bouwen */
			
			$linktmp = cmstemplates::loadfile( 'a/a', 'cmstemplates' );
			$varsd = array();
			$varsd['see'] = cmstemplates::parse($linktmp,array('url'=>'/nl/forum/1'.$this->forumcatid.'/'.$titel.'.htm','text'=>'Reacties ('.$aantal.')'));
			$varsd['react'] = cmstemplates::parse($linktmp,array('url'=>'/nl/forum/3'.$this->forumcatid.'/'.$titel.'.htm','text'=>'Reageer'));
			$vars['discussion'] = cmstemplates::show('discussion', $this->_tablename, $varsd );
		}	
		return cmstemplates::show( $template, $this->_tablename, $vars );
	}

	function showAllByStructure( $input,$structid=CMS_STRUCTURE_ID ) 
	{
	/* 
	input wordt niet gebruikt, maar ivm met compatibiliteit veel sites geven ik de glue hier 0 of 1 als 
	paramater is het toch gehandhaafd.
	$structid is ingevoerd om de content te kunnen tonen op een andere pagina
	 
	*/
	
		$sql='SELECT id FROM '.$this->_tablename.' WHERE sid = \''.$structid.'\' AND language = \''.CMS_CURRENT_LANGUAGE.'\' AND status = \'on\' AND NOT ( ( startshow > \'0\' AND startshow >= \''.time().'\' ) OR ( stopshow > \'0\' AND stopshow < \''.time().'\' ) ) ORDER BY priority';
		$rs = $this->_db->Execute($sql);
		$result = '';
		while($rs && $tmp = $rs->FetchRow() ) {
			$result .= $this->show( $tmp['id'] );
		}
		return $result;
	}
	
		function check() {
		$this->id = intval( $this->id );
		$this->sid = intval( $this->sid );
		$this->pid = intval( $this->pid );
		if( empty( $this->title ) ) {
			$this->title = ADM_CMSARTICLES_TITLE_EMPTY;
		}
		if( !$this->language ) {
			$this->language = CMS_LANGUAGES_DEFAULT;
		}
		$this->language = strtolower( substr( $this->language, 0, 2 ) );
		
		if( isset( $_POST['startshow_year'] ) && $_POST['startshow_year'] && $_POST['startshow_month'] && $_POST['startshow_day'] ) {
			$this->startshow = mktime( 0, 0, 0, $_POST['startshow_month'], $_POST['startshow_day'], $_POST['startshow_year'] );
		} elseif( isset( $_POST['startshow_year'] ) ) {
			$this->startshow = '0';
		}
		if( isset( $_POST['stopshow_year'] ) && $_POST['stopshow_year'] && $_POST['stopshow_month'] && $_POST['stopshow_day'] ) {
			$this->stopshow = mktime( 0, 0, 0, $_POST['stopshow_month'], $_POST['stopshow_day'], $_POST['stopshow_year'] );
		} elseif( isset( $_POST['stopshow_year'] ) ) {
			$this->stopshow = '0';
		}
		
		if( !$this->status ) {
			$this->status = 'on';
		}
		$this->update_time = time();
		if( !$this->insert_time ) {
			$this->insert_time = $this->update_time;
		}
		return true;
	}
}
?>