<?php
/*

EstrateCMS

EstrateCMS is a Content Management System for professional websites.

Copyright (C) 2004, 2005, Estrate, Rudolph Froger, The Netherlands
Website:        http://www.estrate.nl
Postal address: Estrate
                Oostsingel 57B
                2612HD Delft
                The Netherlands

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

A copy of the license should be in the file named LICENSE.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

define( 'MODULE_CMSMODULES', TRUE );

class cmsmodules
{
	var	$_db;
	var	$id;		//internal name of module ie. cmsmodules
	var	$status;	//1 of 0
	var	$admin_level;	//required userrights, none = menu-item is hidden from everyone

	function loadArray( $path = CMS_CONFIG_PATH )
	{
		return loadConfig( $path.'modules.conf', 1 );
	}

	function loadModules($mods='',$admin=false)
	{

		//if(empty($mods))$mods = cmsmodules::loadArray( $cfg['config_path'] );

		if( is_array( $mods ) ) 
		{
			
		/* sort */

		foreach( $mods as $key => $record ) 
		
		{
			if( $record[1] && $record[3]) {
		

	if(preg_match('/_admin$/',$key))
        { 
        $key=str_replace('_admin','',$key);	
	}			
	$pieces=explode('_',$key);
	$path='';
	
	
	
	if(count($pieces)>1)
	{
		for($i=0; $i<count($pieces)-1; $i++)
		{
			$path.=$pieces[$i].'/';
		}	
		$key=$pieces[$i];
	}	
			


	if((file_exists(CMS_CLIENT_PATH.'/modules/'.$path.$key.'/'.$key.'_admin.php') || file_exists(CMS_LIB_PATH.$path.$key.'/'.$key.'_admin.php')) && $admin) 
	{
		$filename = strtolower( $key.'_admin.php' );
	}
	else if(!strstr($key,'_')) $filename = strtolower( $key.'.php' );
	else
	{
		//$key =str_replace('_','/',strtolower($key));
		$filename =preg_replace('/(([a-z]+\/)+)([a-z]+$)/','\\3.php',$key);

	}
				if( file_exists( CMS_CLIENT_PATH.'modules/'.$path.$key.'/'.$filename ) ) {
					//custom library files
					require_once( CMS_CLIENT_PATH.'modules/'.$path.$key.'/'.$filename );
				} elseif( file_exists( CMS_LIB_PATH.$path.$key.'/'.$filename ) ) {
					//modules, within their module folder
					require_once( CMS_LIB_PATH.$path.$key.'/'.$filename );
				}
		
if(is_callable(array($key,'setheaders'))) call_user_func(array($key,'setheaders'),$this->_db); 

			}

		}	
		}
		
	}

	function showAdminMenu(&$acl)
	{
		if( cmsusers::hasRights( 'reviewer', CMS_CURRENT_USER_TYPE ) ) 
		{
			$mods = cmsmodules::loadArray();

			if( is_array( $mods ) ) foreach( $mods as $key => $value ) 
			{
			
			if(!file_exists(CMS_LIB_PATH.$key.'/'.$key.'_admin.php'))
			{
				$key =str_replace('_','/',strtolower($key));
			}
			$configfile=false;
			

			if (file_exists(CMS_CLIENT_PATH.'modules/'.$key.'/config.xml'))$configfile=CMS_CLIENT_PATH.'modules/'.$key.'/config.xml';	
			elseif( file_exists( CMS_LIB_PATH.$key.'/config.xml' ) )$configfile=CMS_LIB_PATH.$key.'/config.xml';
				 if($configfile){
				 	
					$xml_parser = xml_parser_create();
					$config_parser = new cmsmodules_config();
					xml_set_object( $xml_parser, $config_parser );
					xml_set_element_handler( $xml_parser, 'startElement', 'endElement' );
					xml_set_character_data_handler($xml_parser, "characterData");
				
					$fh = fopen( $configfile, 'r' );
					while( $data = fread( $fh, 4096 ) ) {
						$config_parser->reset();
						xml_parse( $xml_parser, $data, feof( $fh ) );
						$mod = $config_parser->mod;
						if( is_array( $mod ) ) {
							$mod['module'] = strtolower( $key );
							$priority = $mod['priority'];
							while( isset( $menuitems[$priority] ) ) {
								$priority++;
							}
						$menuitems[$priority] = $mod;
						}
					}
					fclose( $fh );
					xml_parser_free( $xml_parser );
				}
			}
			$menuitems[0] = array( 'title' => array( 'nl' => 'Samenvatting', 'en' => 'Summary' ),
						'icon' => 'folder_home.png',
						'module' => 'cms',
						'action' =>  'adminSummary'
			);
			
			/* $menuitems[1111] = array( 'title' => array( 'nl' => 'Help', 'en' => 'Help' ),
						'icon' => 'help.png',
						'module' => 'cms',
						'action' => 'adminHelp'
			);*/
			$menuitems[1112] = array( 'title' => array( 'nl' => 'Uitloggen', 'en' => 'Log out' ),
						'icon' => 'stop.png',
						'module' => 'none',
						'action' => 'logout'
			);
			
			ksort( $menuitems );
			$mods['cms'] = array( 'cms', '1', 'reviewer' );
			$mods['none'] = array( 'cms', '1', 'reviewer' );
			$templ = cmstemplates::loadfile( 'menu', 'cmsmodules' );
			$result = '';

			foreach( $menuitems as $item ) {
				
				if(!preg_match('/_admin$/',$item['module']))$item['module']=str_replace('/','_',strtolower($item['module']));
				
				
				if( $mods[$item['module']][1] && $mods[$item['module']][2]<>'none' && 
				(
				cmsusers::hasRights( $mods[$item['module']][2], CMS_CURRENT_USER_TYPE ) 
			    ||
			    !is_null($acl) && $acl->has($mods[$item['module']][0]) && 
				$acl->isAllowed( CMS_CURRENT_USER_ID, $mods[$item['module']][0] , 'admin' )
				
				)
				) 
				{
					$item['title'] = $item['title'][CMS_CURRENT_LANGUAGE];
					if( !isset( $item['action'] ) ) {
						$item['action'] = 'adminList';
					}
					if( $_GET['module'] == 'cms' && $_GET['action'] == $item['action'] ) {
						$item['selected']=' class="selected"';
					} elseif( $_GET['module'] == $item['module'] ) {
						$item['selected']=' class="selected"';
					} else {
						$item['selected']='';
					}
			
					if(
					file_exists(CMS_LIB_PATH.$item['module'].'/'.$item['module'].'_admin.php') 
					||
					file_exists(CMS_CLIENT_PATH.'/modules/'.$item['module'].'/'.$item['module'].'_admin.php') 
					)$item['module'].='_admin';
					$result .= cmstemplates::parse( $templ, $item );
				}
			}
			return $result;
		}
	}

	function create_table( $module, &$db )
	{
		$file = CMS_LIB_PATH.$module.'/'.$module.'.sql';
		if( file_exists( $file ) ) {
			$i = 0;
			$sql = array( $i => '' );
			$fh = fopen( $file, 'r' );
			while( !feof( $fh ) ) {
				$line = trim( fgets( $fh, 4096 ) );
				if( !$line ) {
					$i++;
					$sql[$i] = '';
				} else {
					$sql[$i] .= $line;
				}
			}
			fclose( $fh );
			$success = TRUE;
			foreach( $sql as $sqlstring ) {
				$sqlstring;
				$result = $db->Execute( $sqlstring );
				if( !$result ) {
					$success = FALSE;
				}
			}
			return $success;
		}
		return FALSE;
	}

	function check_tables( &$db )
	{
		return 1;
		$tables = $db->MetaTables();
		$modules = array_keys( cmsmodules::loadArray());
		$missing = array_diff( $modules, $tables );
		foreach( $missing as $mod ) {
			cmsmodules::create_table( $mod, $db );
		}
	}

}

class cmsmodules_config {
	var $inmodule = FALSE;
	var $tag = '';
	var $lang = 'en';
	var $mod = '';

	function startElement( $xml_parser, $tagName, $attr )
	{
		if( $this->inmodule ) {
			$this->tag = $tagName;
			if( $this->tag == 'TITLE' && $attr['LANGUAGE'] ) {
				$this->lang = strtolower( $attr['LANGUAGE'] );
			} elseif( $this->tag == 'TITLE' ) {
				$this->lang = 'en';
			}
		}
		if( $tagName == 'MODULE' ) {
			$this->inmodule = TRUE;
		}
	}
	
	function endElement( $xml_parser, $tagName )
	{
		$this->tag = '';
		$this->lang = '';
		if( $tagName == 'MODULE' ) {
			$this->inmodule = FALSE;
		}
	}
	
	function characterData( $xml_parser, $data )
	{
		switch( $this->tag ) {
			case 'TITLE':
				$this->mod[strtolower($this->tag)][strtolower($this->lang)] = trim( $data );
			break;
			case 'ICON':
			case 'PRIORITY':
			case 'ACTION':
				$this->mod[strtolower($this->tag)] = trim( $data );
			break;
		}
	}

	function reset()
	{
		$this->tag = '';
		$this->lang = '';
		$this->mod = '';
		$this->inmodule = FALSE;
	}
}
?>